import Cocoa
import FlutterMacOS

public class AssistivePlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "plugins.flutter.io/assistive_plugin", binaryMessenger: registrar.messenger)
    let instance = AssistivePlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      result("macOS " + ProcessInfo.processInfo.operatingSystemVersionString)
    case "checkForAssibility":
      result(checkForAssibilityPermission())
    default:
      result(FlutterMethodNotImplemented)
    }
  }
}

private func checkForAssibilityPermission() -> Bool {
    let allow = AXIsProcessTrusted();
    if(allow){
    return true;
    }else{
       //NSWorkspace.shared.open(URL(fileURLWithPath: "x-apple.systempreferences:com.apple.preference?Privacy_Accessibility"));
       let options : NSDictionary = [kAXTrustedCheckOptionPrompt.takeRetainedValue() as NSString: true]
       let accessibilityEnabled = AXIsProcessTrustedWithOptions(options)
    }
    return false;
}